%global php_extdir %(php-config --extension-dir 2>/dev/null || echo "undefined")
%global php_version %((echo 0; php-config --version 2>/dev/null) | tail -1)

# This is the apache userid, used for sysvipc semaphores which is the default
# on ppc since spinlock is not detected (not supported?)
# We also use it for the default ownership of the cache directory
%global apache 48
#global svn   358

Summary: PHP accelerator, optimizer, encoder and dynamic content cacher
Name: php-eaccelerator
Version: 0.9.6.1
#Release: 0.2%{?svn:.svn%{svn}}%{?dist}
Release: 6.fc15.ru
Epoch: 1
# The eaccelerator module itself is GPLv2+
# The PHP control panel is under the Zend license (control.php and dasm.php)
License: GPLv2+ and Zend
Group: Development/Languages
URL: http://eaccelerator.net/
%if 0%{?svn}
Source0: http://snapshots.eaccelerator.net/eaccelerator-svn%{svn}.tar.gz
%else
Source0: http://bart.eaccelerator.net/source/%{version}/eaccelerator-%{version}.tar.bz2
%endif
Source1: php-eaccelerator.cron

BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root
# ABI check is not enough for this extension (http://eaccelerator.net/ticket/438)
#Requires: php-common = %{php_version}
Requires: php-common >= 5.2.0
Provides: php-zend_extension
Conflicts: php-mmcache
BuildRequires: php-devel >= 5.1.0
# Required by phpize
BuildRequires: autoconf, automake, libtool

%description
eAccelerator is a further development of the MMCache PHP Accelerator & Encoder.
It increases performance of PHP scripts by caching them in compiled state, so
that the overhead of compiling is almost completely eliminated.


%prep
%if 0%{?svn}
%setup -q -n eaccelerator-svn%{svn}
%else
%setup -q -n eaccelerator-%{version}
%endif


# Change paths in the example config, other values are changed by a patch
%{__sed} -i 's|/usr/lib/php4/|%{php_extdir}/|g;
             s|/tmp/eaccelerator|%{_var}/cache/php-eaccelerator|g' \
    eaccelerator.ini


%build
phpize
%configure \
%ifnarch %{ix86} x86_64
    --with-eaccelerator-userid="%{apache}"
%endif

%{__make} %{?_smp_mflags}


%install
%{__rm} -rf %{buildroot}
%{__make} install INSTALL_ROOT=%{buildroot}

# The cache directory where pre-compiled files will reside
%{__mkdir_p} %{buildroot}%{_var}/cache/php-eaccelerator

# Drop in the bit of configuration
%{__install} -D -m 0644 eaccelerator.ini \
    %{buildroot}%{_sysconfdir}/php.d/eaccelerator.ini

# Cache removal cron job
%{__install} -D -m 0755 -p %{SOURCE1} \
    %{buildroot}%{_sysconfdir}/cron.daily/php-eaccelerator


%clean
%{__rm} -rf %{buildroot}


%preun
# Upon last removal (not update), clean all cache files
if [ $1 -eq 0 ]; then
    %{__rm} -rf %{_var}/cache/php-eaccelerator/* &>/dev/null || :
fi

%post
# We don't want to require "httpd" in case PHP is used with some other web
# server or without any, but we do want the owner of this directory to default
# to apache for a working "out of the box" experience on the most common setup.
#
# We can't store numeric ownerships in %%files and have it work, so "fix" here,
# but only change the ownership if it's the current user (which is root), which
# allows users to manually change ownership and not have it change back.

# Create the ghost'ed directory with default ownership and mode
if [ ! -d %{_var}/cache/php-eaccelerator ]; then
    %{__mkdir_p} %{_var}/cache/php-eaccelerator
    %{__chown} %{apache}:%{apache} %{_var}/cache/php-eaccelerator
    %{__chmod} 0750 %{_var}/cache/php-eaccelerator
fi


%check
# only check if build extension can be loaded
%{_bindir}/php \
    -n -q -d extension_dir=modules \
    -d extension=eaccelerator.so \
    --modules | grep eAccelerator


%files
%defattr(-,root,root,-)
%doc AUTHORS ChangeLog COPYING NEWS README*
%doc eaccelerator.ini *.php
%{_sysconfdir}/cron.daily/php-eaccelerator
%config(noreplace) %{_sysconfdir}/php.d/eaccelerator.ini
%{php_extdir}/eaccelerator.so
# We need this hack, as otherwise rpm resets ownership upon package upgrade
#attr(0750,apache,apache) %{_var}/cache/php-eaccelerator/
#attr(0750,root,root) %verify(not user group) %{_var}/cache/php-eaccelerator/
%ghost %{_var}/cache/php-eaccelerator/


%changelog
* Fri Feb 18 2011 Vaibhav Verma <vverna@nbcs.rutgers.edu> - 0.9.6.1-5.fc15.ru
- Initial Build

